'use strict';

const logger = require('@finect/logger');

const middlewares = require('@finect/api-middlewares');
const SwaggerExpress = require('swagger-express-mw');
const app = require('express')();

class Workers {
    constructor(config) {
        app.set('json replacer', middlewares.ignoreUnderscoreJsonProperties);
        this.config = config;
    }

    run(listened) {   
        SwaggerExpress.create(this.config, (err, swaggerExpress) => {
            if (err) { throw err; }
        
            app.get('/favicon.ico', (req, res) => {
                res.sendStatus(204);
            });
       
            
            // install middleware
            app.use(middlewares.response);
            swaggerExpress.register(app);
        
            app.use(middlewares.errors);
            
            const port = process.env.PORT || 10010;
            app.listen(port, listened);
        
            logger.info('API started at port: %s', port);
        });
    }
}

if (module.parent) {
    module.exports = Workers;
} else {
    new Workers();
    logger.info('debugger');
}    




