
module.exports = function create() {
  return function swaggerMiddleware(context, cb) {
      
    if (context.request.headers['x-authenticated-userid']) {
        context.request.swagger.params['x-authenticated-userid'] = context.request.headers['x-authenticated-userid'];
    }

    if ((process.env.NODE_ENV || '').toLowerCase() != 'production') allowNullType(context.request.swagger);
    cb(null, context);
  };
};

function allowNullType(swagger) {
  Object.keys(swagger).map(k => {
      
      if (k === 'x-nullable') {
          if (!Array.isArray(swagger.type) && swagger[k] !== undefined && swagger[k]) {
              if (!swagger.type) swagger.type = 'object';
              swagger.type = [ swagger.type, 'null'];
          }

          return;
      }

      if (swagger[k] && typeof swagger[k] === 'object') {
          allowNullType(swagger[k]);
      }
  });
}