'use strict'

module.exports.registerRootRequire = () => {
    global.rootRequire = function(name) {
        return require(__dirname + '/' + name);
    }
}

// Global property to know if environment is production or not.
module.exports.isNotProduction = () => ((process.env.NODE_ENV || '').toLowerCase() != 'production');

// Wrap express route to call async.
module.exports.wrapAsync = (fn) => {
    return (req, res, next) => {
      Promise.resolve(fn(req, res, next)).catch(next);
    };
};

// foreach async
module.exports.asyncForEach = async (array, callback) => {
    for (let index = 0; index < array.length; index++) {
      await callback(array[index], index, array)
    }
}